#boat

scoreboard players remove @e[scores={ships.boat.cooldown=-99..}] ships.boat.cooldown 1
scoreboard players reset @e[scores={ships.boat.cooldown=..1},predicate=!ships:on_boat] ships.boat.cooldown

execute as @e[type=#ships:uses_boat] unless score @s ships.boat.cooldown matches 0.. at @s unless entity @e[tag=ships.boat,distance=0..1] if predicate ships:water positioned ~ ~1.1 ~ unless predicate ships:water at @s run function ships:boat/spawn
execute as @e[type=#ships:uses_boat] if predicate ships:target if predicate ships:on_boat on vehicle at @s run function ships:boat/turn
execute as @e[type=#ships:uses_boat_ranged] if predicate ships:target if predicate ships:on_boat on vehicle at @s run function ships:boat/move_ranged
execute as @e[type=#ships:uses_boat_melee] if predicate ships:target if predicate ships:on_boat on vehicle at @s run function ships:boat/move_melee

execute as @e[tag=ships.boat] on passengers at @s run data modify entity @s Rotation[0] set from entity @e[limit=1,sort=nearest,type=minecraft:boat] Rotation[0]
execute as @e[tag=ships.boat] on controller unless score @s ships.boat.cooldown matches 0.. at @s rotated ~ 0 positioned ^ ^.5 ^ unless predicate ships:water run function ships:boat/dismount
execute as @e[tag=ships.boat] on controller unless score @s ships.boat.cooldown matches 0.. at @s rotated ~ 0 positioned ^ ^.5 ^ if predicate ships:water positioned ^ ^ ^1 unless predicate ships:water run function ships:boat/dismount
execute as @e[tag=ships.boat] on controller if entity @s[nbt={Health:0f}] on vehicle run data modify entity @s Motion[1] set value -.25

scoreboard players set @e[tag=ships.boat,scores={ships.boatai.controller=1}] ships.boatai.controller 0
execute as @e[tag=ships.boat] store success score @s ships.boatai.controller on controller if entity @s
execute as @e[tag=ships.boat,scores={ships.boatai.controller=0}] on passengers run kill @s[type=marker]
execute as @e[tag=ships.boat,scores={ships.boatai.controller=0}] run kill @s

execute as @e[tag=ships.boatai.lock] at @s unless entity @e[type=minecraft:boat,distance=0..1] run kill @s

execute as @e[tag=ships.action.patrol,limit=1,sort=random] run function ships:boat/patrol/set
tag @e[tag=ships.action.patrol,tag=ships.patrol] remove ships.action.patrol
execute as @e[tag=ships.patrol,predicate=!ships:target,predicate=ships:on_boat] if data entity @s PatrolTarget on vehicle at @s run function ships:boat/move_melee
execute as @e[tag=ships.patrol,predicate=!ships:target,predicate=ships:on_boat,limit=10,sort=random] if data entity @s PatrolTarget on vehicle at @s run function ships:boat/patrol/turn
execute as @e[tag=ships.patrol,predicate=!ships:target,predicate=ships:on_boat,predicate=ships:patrol/forget_chance] if data entity @s PatrolTarget on vehicle on passengers if entity @s[tag=ships.boatai.boat] at @s run function ships:boat/patrol/find
kill @e[tag=ships.boatai.patrol.turn]
#ship
#summon marker ~ ~ ~ {Tags:["ships.spawner"],data:{center:0}}
execute as @e[tag=ships.spawner,nbt={data:{center:0}}] at @s if loaded ~-16 ~ ~-16 if loaded ~-16 ~ ~ if loaded ~-16 ~ ~16 if loaded ~ ~ ~-16 if loaded ~ ~ ~ if loaded ~ ~ ~16 if loaded ~16 ~ ~-16 if loaded ~16 ~ ~ if loaded ~16 ~ ~16 run function ships:ship/secondary
execute as @e[tag=ships.spawner,nbt={data:{center:0}}] at @s if loaded ~-16 ~ ~-16 if loaded ~-16 ~ ~ if loaded ~-16 ~ ~16 if loaded ~ ~ ~-16 if loaded ~ ~ ~ if loaded ~ ~ ~16 if loaded ~16 ~ ~-16 if loaded ~16 ~ ~ if loaded ~16 ~ ~16 run function ships:ship/secondary
execute as @e[tag=ships.spawner] at @s if loaded ~-16 ~ ~-16 if loaded ~-16 ~ ~ if loaded ~-16 ~ ~16 if loaded ~ ~ ~-16 if loaded ~ ~ ~ if loaded ~ ~ ~16 if loaded ~16 ~ ~-16 if loaded ~16 ~ ~ if loaded ~16 ~ ~16 if block ~ ~ ~ minecraft:furnace run function ships:ship/secondary
execute as @e[tag=ships.spawner,nbt={data:{center:0}}] at @s if loaded ~-16 ~ ~-16 if loaded ~-16 ~ ~ if loaded ~-16 ~ ~16 if loaded ~ ~ ~-16 if loaded ~ ~ ~ if loaded ~ ~ ~16 if loaded ~16 ~ ~-16 if loaded ~16 ~ ~ if loaded ~16 ~ ~16 unless block ~ ~ ~ minecraft:furnace run data modify entity @s data.center set from entity @s Pos